// MediaViewer.h: CMediaViewer NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#pragma once


// VMR9Ή by HDUSTest̒̐l
#define VMR9_SUPPORTED


#include "MediaDecoder.h"
#include "TsUtilClass.h"
#include "BonSrcFilter.h"
#include "AacDecFilter.h"
#include "Mpeg2SequenceFilter.h"
#include "PcmSelectFilter.h"
#include <Bdaiface.h>
#include "EnumFilter.h"


/////////////////////////////////////////////////////////////////////////////
// fBAr[A(fyщĐ)
/////////////////////////////////////////////////////////////////////////////
// Input	#0	: CTsPacket		̓f[^
/////////////////////////////////////////////////////////////////////////////

class CMediaViewer : public CMediaDecoder  
{
public:
	CMediaViewer(IEventHandler *pEventHandler = NULL);
	virtual ~CMediaViewer();

// IMediaDecoder
	virtual void Reset(void);
	virtual const bool InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex = 0UL);

// CMediaViewer
	const bool OpenViewer(HWND hOwnerHwnd = NULL,HWND hMessageDrainHwnd = NULL);
	void CloseViewer(void);

	const bool Play(void);
	const bool Stop(void);
	
	const bool SetVideoPID(const WORD wPID);
	const bool SetAudioPID(const WORD wPID);

	// Append by Meru
	const bool ResizeVideoWindow();
	const bool SetViewSize(const int x,const int y);
	const bool SwitchFullscreen();
	const bool SetVolume(const float fVolume);
	const bool GetVideoSize(WORD *pwWidth,WORD *pwHeight);
	const bool GetVideoAspectRatio(BYTE *pbyAspectRatioX,BYTE *pbyAspectRatioY);
	const BYTE GetAudioChannelNum();
	const bool SetStereoMode(const int iMode);
	const bool GetVideoDecorderName(LPWSTR lpName,int iBufLen);
	const bool DisplayVideoDecorderProperty(HWND hWndParent);
	const bool DisplayVideoRanderProperty(HWND hWndParent);

	// Append by HDUSTest̒̐l
	bool ForceAspectRatio(int AspectX,int AspectY);
	const bool GetEffectiveAspectRatio(BYTE *pAspectX,BYTE *pAspectY);
	enum { PANANDSCAN_HORZ=1, PANANDSCAN_VERT=2 };
	bool SetPanAndScan(BYTE bFlags);
	const bool GetPanAndScanVideoSize(WORD *pwWidth,WORD *pwHeight);
	const bool GetDestRect(RECT *pRect);
	const bool GetDestSize(WORD *pWidth,WORD *pHeight);
	const bool GetSourceRect(RECT *pRect);
	const void HideCursor(bool bHide);
#ifdef VMR9_SUPPORTED
	bool SetVMR9(bool bVMR9);
	bool GetCurrentImage(BYTE **ppDib);
	bool RepaintVideo(HWND hwnd,HDC hdc);
	bool DisplayModeChanged();
#endif
protected:
	CCriticalLock m_CriticalLock;

	// DirectShowC^tF[X
	bool m_bInit;
	IMediaControl *m_pMediaControl;
	
	// DirectShowtB^
	IGraphBuilder *m_pFilterGraph;
	CBonSrcFilter *m_pBonSrcFilter;
	CAacDecFilter *m_pAacDecFilter;
	CMpeg2SequenceFilter *m_pMpeg2SeqFilter;
	CPcmSelectFilter *m_pPcmSelFilter;
	IBaseFilter *m_pMp2DemuxFilter;
	IBaseFilter *m_pMpeg2DecFilter;
	CStringW m_strMpeg2DecorderName;

	// MPEG2DemultiplexerC^tF[X
	IMpeg2Demultiplexer *m_pMp2DemuxInterface;
	IReferenceClock *m_pMp2DemuxRefClock;

	// rfIPID}bv
	IMPEG2PIDMap *m_pMp2DemuxVideoMap;
	IMPEG2PIDMap *m_pMp2DemuxAudioMap;

	// rfIEBhE
	IVideoWindow *m_pVideoWindow;

	// rfI
	IBasicVideo2 *m_pBasicVideo;

	// I[fBI
	IBasicAudio *m_pBasicAudio;
	
	// Elementary StreamPID
	WORD m_wVideoEsPID;
	WORD m_wAudioEsPID;

	static void CALLBACK OnMpeg2VideoInfo(const Mpeg2VideoInfo *pVideoInfo,const LPVOID pParam);
	WORD m_wVideoWindowX;
	WORD m_wVideoWindowY;
	Mpeg2VideoInfo m_VideoInfo;
	HWND m_hOwnerWnd;
	bool m_bFullscreen;
	
private:
	HRESULT AddToRot(IUnknown *pUnkGraph, DWORD *pdwRegister) const;
	void RemoveFromRot(const DWORD pdwRegister) const;

	DWORD m_dwRegister;

	// Append by HDUSTest̒̐l
	int m_ForceAspectX,m_ForceAspectY;
	BYTE m_PanAndScan;
#ifdef VMR9_SUPPORTED
	bool m_bVMR9;
	IBaseFilter *m_pVMR9;
	IPin *m_pMpeg2DemuxVideoPin;
#endif
};
